//+------------------------------------------------------------------
//|                                     Klinger volume oscillator.mq4 
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DeepSkyBlue
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  Blue
#property indicator_color6  Maroon
#property indicator_width1  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int  LongEma             = 55;
extern int  ShortEma            = 34;
extern int  SignalEma           = 13;
extern bool UseRangeCalculation = true;

double kvoUp[];
double kvoUd[];
double kvoDd[];
double kvoDu[];
double kvoNu[];
double kvoNd[];
double signal[];
double slope[];

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);      
   SetIndexBuffer(0,kvoUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,kvoUd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,kvoDd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,kvoDu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,kvoNu); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,kvoNd); SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexBuffer(6,signal);
   SetIndexBuffer(7,slope); 
      string add =""; 
         if (UseRangeCalculation) add = "using range";
   IndicatorShortName("Klinger volume "+add+" oscillator ("+LongEma+","+ShortEma+","+SignalEma+") ");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

double work[][7];
#define _price 0
#define _trend 1
#define _dm    2
#define _cm    3
#define _ema1  4
#define _ema2  5
#define _kvo   6

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   double alpha1 = 2.0/(1.0+LongEma);
   double alpha2 = 2.0/(1.0+ShortEma);
   double alpha3 = 2.0/(1.0+SignalEma);
   
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][_price] = (High[i]+Low[i]+Close[i])/3.0;
         work[r][_trend] = work[r-1][_trend];
         
            if (work[r][_price]>work[r-1][_price]) work[r][_trend] =  1;
            if (work[r][_price]<work[r-1][_price]) work[r][_trend] = -1;
         
            //
            //
            //
            //
            //
            
            double volume;
               if (UseRangeCalculation)
               {
                  work[r][_dm] = High[i]-Low[i];
                     if (work[r][_trend]==work[r-1][_trend])
                           work[r][_cm] = work[r-1][_cm]+work[r][_dm];
                     else  work[r][_cm] = work[r-1][_dm]+work[r][_dm];
                     if (work[r][_cm]!=0)
                           volume = work[r][_trend]*Volume[i] * MathAbs(2.0*work[r][_dm]/work[r][_cm] - 1.0);
                     else  volume = work[r][_trend]*Volume[i];
               }
               else volume = work[r][_trend]*Volume[i];

            //
            //
            //
            //
            //
            
            work[r][_ema1] = work[r-1][_ema1]+alpha1*(volume-work[r-1][_ema1]);
            work[r][_ema2] = work[r-1][_ema2]+alpha2*(volume-work[r-1][_ema2]);
            work[r][_kvo]  = work[r][_ema2]-work[r][_ema1];
               if (SignalEma>1) signal[i] = signal[i+1]+alpha3*(work[r][_kvo]-signal[i+1]);
            slope[i]  = slope[i+1];               
               kvoUp[i] = EMPTY_VALUE;
               kvoUd[i] = EMPTY_VALUE;
               kvoDd[i] = EMPTY_VALUE;
               kvoDu[i] = EMPTY_VALUE;
               kvoNu[i] = EMPTY_VALUE;
               kvoNd[i] = EMPTY_VALUE;
               if (work[r][_kvo]>work[r-1][_kvo]) slope[i] =  1;
               if (work[r][_kvo]<work[r-1][_kvo]) slope[i] = -1;
               if (work[r][_kvo] > 0 && work[r][_kvo]>signal[i])
               {
                  if (slope[i]==1)
                        kvoUp[i] = 1;
                  else  kvoUd[i] = 1;
                  continue;
               }                  
               if (work[r][_kvo] < 0 && work[r][_kvo]<signal[i])
               {
                  if (slope[i]==1)
                        kvoDu[i] = 1;
                  else  kvoDd[i] = 1;
                  continue;
               }                  
               if (work[r][_kvo] > 0)
                     kvoNu[i] = 1;
               else  kvoNd[i] = 1;        
      }
   
   return(0);
}